// Global functions that are run site wide
var global = {
    showCTA: function(){
        // If Banner CTA is in VIEW, hide header Play Button
        var $bannerCTA = $('.cta-splash'), $ctaWrap = $('#cta');
        if(!$bannerCTA.is(':appeared')) $ctaWrap.addClass('cta-show');
        $(window).scroll(function(){
            var ctaInView = $bannerCTA.is(':appeared');
            !ctaInView ? $ctaWrap.addClass('cta-show') : $ctaWrap.removeClass('cta-show');
        });
    },
    showBackgrounds: function(){
        var $section = $('section');
        $section.each(function(){
            var $self = $(this);
            if($self.is(':appeared')) $self.addClass('loaded');
        });
        $section.appear();
        $section.on('appear', function(e, $affected){
            $(this).addClass('loaded');
        });
    },
    carousel: function(){
        var $carousel = $('#carousel');
        $carousel.flexslider({
            controlNav: false
        });
    },
    init: function(){
        global.showCTA();
        global.carousel();
  global.showBackgrounds();
    }
};
// Feature detection for mobile instead of out of date Regex
var mobile = {
    detection: function(){
        return (typeof window.orientation != 'undefined');
    },
    language: function(){
     $('#language').on('click touchstart', function(){
      $(this).addClass('open');
     });
    },
    init: function(){
        // If mobile, add class to body, hide buttons and show warning in CSS
        if(mobile.detection()) {
            document.body.className += ' mobile';
            mobile.language();
            $('section').addClass('loaded');
        }
    }
};
// Tracking functions from BI and Google
var tracking = {
 getParameterByName: function(name) {
     name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
     var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
         results = regex.exec(location.search);
     return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
 },
    load: function(page){
        var track = new Image();
        track.src = baseURL+'/img/track/track.gif?jptg=rswf2ms&jptv='+page+'-land';
    },
    link: function(e,page,action){
        var track = new Image(), splitter = '-';
        (e.parents().hasClass('navigation') || e.attr('id') === 'nav-open-btn' || e.attr('id') === 'logo') ? splitter = '-nav|' : '-';
        track.src = baseURL+'/img/track/track.gif?jptg=rswf2ms&jptv='+page+splitter+action;
    },
    google: function(action){
     // If a Play Button is clicked, currentPage set on page
     if(action === 1 || action === 2 || action === 3){
      var category;
      switch(action){
             case 1 :
                 category = 'play_button_topnav';
                 break;
             case 2 :
                 category = 'play_button_main';
                 break;
             case 3 :
                 category = 'play_button_bottom';
                 break;
             default:
                 category = 'undefined';
         }
      _gaq.push(['_trackEvent', category, 'click', currentPage]);
     }
    },
    webuid: function(){
     var cookieName = 'JXFRONTUID';
     if($.cookie(cookieName) === undefined){
      var webuid = 'x4xxxxxxxxxxxyxxxx'.replace(/[xy]/g, function(c) {var r = Math.random()*16|0,v=c=='x'?r:r&0x3|0x8;return v.toString(16);});
      $.cookie(cookieName, webuid, { path: '/' , domain: '.runescape.com'});
     }
    },
    marketing: function(){
     // affiliate set in page footer
     var page = document.body.id, bidalgo = '934', dauUp = '935'; 
     if(affiliate === bidalgo) {
      var cookieName = 'bidalgouid', uid = this.getParameterByName('uid');
      if(uid) $.cookie(cookieName, uid, { path: '/' , domain: '.runescape.com'});
     }
     //DAU-UP
     else if(affiliate === dauUp && page === 'splash'){
      var cookieName = 'dauupid', aid = this.getParameterByName('aid'), track = new Image();
      if(aid) $.cookie(cookieName, aid, { path: '/' , domain: '.runescape.com'});
      track.src = 'https://srv.ministerial5.com/convnew/?t=6&l=6&aid='+aid;
     }
    },
    init: function(){
        var page = document.body.id;
        switch(page){
            case 'splash' :
                page = 1000;
                break;
            case 'what-is-runescape' :
                page = 1100;
                break;
            case 'game-features' :
                page = 1200;
                break;
            case 'community' :
                page = 1300;
                break;
            case 'upgrades-extras' :
                page = 1400;
                break;
            case 'old-school' :
                page = 1500;
                break;
            case 'promo' :
                page = 1600;
                break;
            default:
                page = 0;
        }
        // Page load tracking
        if(page != 0) {
         tracking.load(page);
         tracking.webuid();
         tracking.marketing();
         // On click, grab data-track attribute and fire tracking pixel
         $('a:not(.flex-direction-nav a)').click(function(e){
             e.preventDefault();
             var $self = $(this), action = $self.data('track'), href = this.href, target = this.target === '_blank';
             if(typeof action != 'undefined') {
                 tracking.link($self,page,action);
                 tracking.google(action);
             }
             setTimeout(function(){target ? window.open(href) : WB_wombat_self_location.href = href;}, 100);
         });
        }
    }
};
// onLoad function run on every page by default
var onLoad = {
    init: function(){
        global.init(); // Global functions
        mobile.init(); // Mobile feature detection
        tracking.init(); // Tracking for BI
    }
};
// Run onLoad init function when document is ready
$(document).ready(onLoad.init);